package com.chapter16.tankgame;

import java.util.Vector;

// 敌人坦克类
public class EnemyTank extends Tank implements Runnable{
    // 使用Vector类 保存 多个shot 子弹
    Vector<Shot> shots = new Vector<>();

    boolean isLive = true; // 坦克生命

    public EnemyTank(int x, int y) {
        super(x, y);
    }

    @Override
    public void run() {

        while (true){

            // 判断，如果shots的集合为0 并且坦克还存活，则创建一个子弹，放入到集合中,并启动
            if (isLive && shots.size() < 5){
                Shot s = null;
                // 判断坦克的方向，创建对应的子弹
                switch (getDirect()){
                    case 0:
                        s = new Shot(getX() + 18,getY() - 25,0);
                    case 1:
                        s = new Shot(getX(),getY() + 20,1);
                        break;
                    case 2:
                        s = new Shot(getX() - 15,getY(),2);
                        break;
                    case 3:
                        s = new Shot(getX() + 20,getY(),3);
                        break;
                }

                shots.add(s);
                new Thread(s).start();

            }

            // 根据坦克的方向来继续移动
            switch (getDirect()){

                case 0:
                    // 让坦克保持一个方向走30步
                    for (int i = 0; i < 50 + (int) (Math.random() * 100); i++) {
                        if (getY() > 20){
                            moveUp();
                        }

                        try {
                            Thread.sleep(50);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }

                    break;
                case 1:
                    for (int i = 0; i < 50 + (int) (Math.random() * 100); i++) {
                        if (getY() + 115 < 750){
                            moveDown();
                        }

                        try {
                            Thread.sleep(50);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                    break;
                case 2:
                    for (int i = 0; i < 50 + (int) (Math.random() * 100); i++) {

                        if (getX() > 20){
                            moveLeft();
                        }

                        try {
                            Thread.sleep(50);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }

                    break;
                case 3:
                    for (int i = 0; i < 50 + (int) (Math.random() * 100); i++) {

                        if (getX() + 95 < 1000){
                            moveRight();
                        }

                        try {
                            Thread.sleep(50);
                        } catch (InterruptedException e) {
                            e.printStackTrace();
                        }
                    }
                    break;
            }

            // 休眠
            try {
                Thread.sleep(50);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }

            // 然后随机的改变坦克的方向
            setDirect((int) (Math.random() * 4));

            // 什么时候退出线程
            if (!isLive){
                break;
            }

        }
    }
}
